unit paint_unit;

{ holds Gmap; paint procedures for Gmap and paintbox1}

interface

uses windows,extctrls,graphics,sysutils,classes;

type Tline = record
              x1,y1 : byte;
              x2,y2 : byte;
              color : dword;
              valid : boolean;
             end;

procedure paintedges(box : TPaintbox; col : dword);
procedure clearedges(box : TPaintbox);
procedure eraseFieldRect(const r : Trect);
procedure paintRightBridges(const r : Trect; nr : byte);
procedure paintLeftBridges(const r : Trect; nr : byte);
procedure paintTopBridges(const r : Trect; nr : byte);
procedure paintDownBridges(const r : Trect; nr : byte);
procedure paintHbridges(const r : Trect; nr : byte);
procedure paintVbridges(const r : Trect; nr : byte);
procedure paintIsland(const r : Trect; bc : byte);
procedure paintField(x,y : byte);
procedure paintgame;
procedure paintline(const line : Tline);
procedure clearline;
function getFieldRect(x,y : byte) : Trect;
procedure Gmapfield2box(x,y : byte);
procedure GmapRect2box(const r : Trect);
procedure copymap2box;
procedure LightGroup(grp : byte);
procedure paintredIsland(n : byte);
procedure clearRedIsland;

var Gmap : Tbitmap;

implementation

uses unit1,game_unit;

const rastercolor = $ffe0e0;
      bgcolor = $e0e0e0;
      brOffset : array[1..3,0..3] of byte = ((5,7,7,5),
                                             (6,8,8,5),
                                             (5,8,8,6));
      offsetY : array[0..3] of byte = (0,18,15,21);

var linerect : Trect;
    linerectOK : boolean;
    redIsland : byte; //0: none

function getFieldRect(x,y : byte) : Trect;
begin
 with result do
  begin
   left := (x-1)*40;
   top := (y-1)*40;
   right := left + 40;
   bottom := top + 40;
  end;
end;

procedure copymap2box;
//copy maprect rectangle of Gmap to paintbox1
begin
 form1.PaintBox1.Canvas.Draw(0,0,Gmap);
end;

procedure GmapRect2box(const r : Trect);
begin
 form1.PaintBox1.Canvas.CopyRect(r,Gmap.Canvas,r);
end;

procedure Gmapfield2box(x,y : byte);
var r : Trect;
begin
 r := getFieldRect(x,y);
 GmapRect2box(r);
end;

procedure clearRedIsland;
begin
 if redIsland > 0 then
  begin
   with island[redIsland] do GmapField2box(x,y);
   redIsland := 0;
  end;
end;

procedure paintredIsland(n : byte);
//n= 0 clears redIsland
var r : Trect;
begin
 with island[n] do r := getFieldrect(x,y);
 with form1.paintbox1.Canvas do
  begin
   pen.Width := 2;
   pen.Color := $ff;
   brush.Style := bsClear;
   ellipse(r.Left+4,r.Top+4,r.Right-4,r.bottom-4);
  end;
 redIsland := n;
end;

procedure paintedges(box : TPaintbox; col : dword);
var x1,y1,x2,y2 : word;
     i : byte;
begin
 with box do
  begin
   x1 := left - 2;
   y1 := top - 2;
   x2 := left + width + 1;
   y2 := top + height + 1;
  end;
 with form1.canvas do
  begin
   pen.width := 1;
   pen.Color := col;
   for i := 0 to 1 do
    begin
     moveto(x2-i,y1 + i);
     lineto(x1+i,y1+i);
     lineto(x1+i,y2-i);
     lineto(x2-i,y2-i);
     lineto(x2-i,y1+i);
    end;
  end;
end;

procedure clearedges(box : TPaintbox);
//clear edges on form1
var col : dword;
begin
 col := form1.Canvas.Pixels[1,50];
 paintedges(box,col);
end;

procedure eraseFieldRect(const r : Trect);
begin
 with Gmap.Canvas do
  begin
   brush.style := bsSolid;
   fillrect(r);
   pen.Color := rastercolor;
   pen.Width := 1;

   moveto(r.Left+20,r.Top); lineto(r.left+20,r.Bottom);
   moveto(r.Left,r.Top+20); lineto(r.right,r.top+20);
  end;
end;

function GetRightBridges(x,y : byte) : byte;
//search game[ ]
begin
 result := 0;
 if (x < gamesize - 1) then
  with game[x+1,y] do
   if (ftype = ftHbridge) then result := brCount;
end;

function GetLeftBridges(x,y : byte) : byte;
//search game[ ]
begin
 result := 0;
 if (x > 2) then
  with game[x-1,y] do
   if (ftype = ftHbridge) then result := brCount;
end;

function GetUpBridges(x,y : byte) : byte;
//search game
begin
 result := 0;
 if (y > 2) then
  with game[x,y-1] do
   if (ftype = ftVbridge) then result := brCount;
end;

function GetDownBridges(x,y : byte) : byte;
//search game[ ]
begin
 result := 0;
 if (y < gamesize - 1) then
  with game[x,y+1] do
   if (ftype = ftVbridge) then result := brCount;
end;

procedure paintRightBridges(const r : Trect; nr : byte);
var x,y : word;
    i,n : byte;
    bias : byte;
begin
 bias := nr - 1;
 with Gmap.Canvas do
  for n := 1 to nr do
   begin
    y := r.top + offsetY[n+bias];
    pen.Width := 1;
    for i := 0 to 3 do
     begin
      if (i = 0) or (i = 3) then pen.Color := 0 else pen.Color := bgColor;
      x := r.right - brOffset[n+bias,i];
      moveto(x,y); lineto(r.right,y);
      inc(y);
     end;
  end;
end;

procedure paintLeftBridges(const r : Trect; nr : byte);
var x,y : word;
    i,n,bias : byte;
begin
 bias := nr - 1;
 with Gmap.Canvas do
  for n := 1 to nr do
   begin
    y := r.top + offsetY[n+bias];
    pen.Width := 1;
    for i := 0 to 3 do
     begin
      if (i = 0) or (i = 3) then pen.Color := 0 else pen.Color := bgColor;
      x := r.left + brOffset[n+bias,i];
      moveto(r.Left,y); lineto(x,y);
      inc(y);
     end;
  end;
end;

procedure paintTopBridges(const r : Trect; nr : byte);
//paint vertical bridge(s) in Gmap//s,d are source, destination rectangles
var x,y : word;
    i,n,bias : byte;
begin
 bias := nr - 1;
 with Gmap.Canvas do
  for n := 1 to nr do
   begin
    x := r.Left + offsetY[n+bias];
    pen.Width := 1;
    for i := 0 to 3 do
     begin
      if (i = 0) or (i = 3) then pen.Color := 0 else pen.Color := bgColor;
      y := r.top + brOffset[n+bias,i];
      moveto(x,r.top); lineto(x,y);
      inc(x);
     end;
  end;
end;

procedure paintDownBridges(const r : Trect; nr : byte);
//paint vertical bridge(s) in Gmap//s,d are source, destination rectangles
var x,y : word;
    i,bias,n : byte;
begin
 bias := nr - 1;
 with Gmap.Canvas do
  for n := 1 to nr do
   begin
    x := r.Left + offsetY[n+bias];
    pen.Width := 1;
    for i := 0 to 3 do
     begin
      if (i = 0) or (i = 3) then pen.Color := 0 else pen.Color := bgColor;
      y := r.bottom - brOffset[n+bias,i];
      moveto(x,r.bottom); lineto(x,y);
      inc(x);
     end;
  end;
end;

procedure paintHbridges(const r : Trect; nr : byte);
//paint horizontal bridge(s) in Gmap
var y : word;
    bias,i,n : byte;
begin
 if nr = 1 then bias := 0 else bias := 1;
 for n := 1 to nr do
  with Gmap.Canvas do
   begin
    y := r.top + offsetY[n+bias];
    pen.Width := 1;
    for i := 0 to 3 do
     begin
      if (i = 0) or (i = 3) then pen.Color := 0 else pen.Color := bgColor;
      moveto(r.left,y); lineto(r.right,y);
      inc(y);
     end;
   end;
end;

procedure paintVbridges(const r : Trect; nr : byte);
//paint vertical bridge(s) in Gmap
var x : word;
    bias,i,n : byte;
begin
 if nr = 1 then bias := 0 else bias := 1;
 for n := 1 to nr do
  with Gmap.Canvas do
   begin
    x := r.Left + offsetY[n+bias];
    pen.Width := 1;
    for i := 0 to 3 do
     begin
      if (i = 0) or (i = 3) then pen.Color := 0 else pen.Color := bgColor;
      moveto(x,r.top); lineto(x,r.bottom);
      inc(x);
     end;
   end;
end;

procedure paintIsland(const r : Trect; bc : byte);
begin
 with Gmap do with canvas do
  begin
   pen.Width := 2;
   pen.Color := 0;
   brush.style := bsSolid;
   brush.Color := bgColor;
   ellipse(r.Left+4,r.Top+4,r.Right-4,r.Bottom-4);
   brush.Style := bsClear;
   textout(r.Left+15,r.top+11,inttostr(bc));
  end;
end;

procedure paintField(x,y : byte);
var r : Trect;
    bnr : byte;
begin
 r := getFieldRect(x,y);
 eraseFieldRect(r);
 with game[x,y] do
   case ftype of
    ftNone : ;
    ftIsland : begin
                paintIsland(r,game[x,y].brCount);
                bnr := getRightBridges(x,y);
                if bnr > 0 then paintRightbridges(r,bnr);
                bnr := getLeftBridges(x,y);
                if bnr > 0 then paintleftbridges(r,bnr);
                bnr := getUpBridges(x,y);
                if bnr > 0 then painttopbridges(r,bnr);
                bnr := getDownBridges(x,y);
                if bnr > 0 then paintdownbridges(r,bnr);
               end; //ftIsland
    ftHbridge : paintHBridges(r,brCount);
    ftVbridge : paintVbridges(r,brCount)
   end;
end;

procedure paintgame;
var i,j : byte;
begin
 for j := 1 to gamesize do
  for i := 1 to gamesize do paintField(i,j);
 form1.PaintBox1.Canvas.Draw(0,0,Gmap);
end;

procedure clearline;
begin
 if linerectOK then
  begin
   form1.PaintBox1.Canvas.CopyRect(linerect,Gmap.Canvas,linerect);
   linerectOK := false;
  end;
 if redIsland > 0 then paintredIsland(redIsland);
end;

procedure paintline(const line : Tline);
var px1,py1,px2,py2 : word;
    H,V : boolean;
    p : word;
begin
 px2 := 0; py2 := 0;
 clearline;
//
 with line do
  begin
   px1 := x1;
   py1 := y1;
   H := ((x1 <> x2) and (y1 = y2));
   V := ((x1 = x2) and (y1 <> y2));
   If H then
    begin
     px2 := x2;
     py2 := y1;
    end;
   if V then
    begin
     px2 := x1;
     py2 := y2;
   end;
  end;
  if px1 > px2 then
   begin
    p := px1; px1 := px2; px2 := p;
   end;
  if py1 > py2 then
   begin
    p := py1; py1 := py2; py2 := p;
   end;
  px1 := (px1-1)*40;
  py1 := (py1-1)*40;
  px2 := px2*40;
  py2 := py2*40;
  if H then
   begin
    px1 := px1+20;
    px2 := px2-20;
   end;
  if V then
   begin
    py1 := py1 + 20;
    py2 := py2-20;
   end;   
  with form1.PaintBox1.Canvas do
   begin
    pen.color := line.color;
    pen.width := 3;
    moveto(px1+20,py1+20);
    lineto(px2-20,py2-20);
   end;
 linerect := rect(px1,py1,px2,py2);
 linerectOK := true;
end;

function GetRightIsCoords(x,y : byte; var n : byte) : boolean;
//x,y are island coords
//if true n is right island x
var i : byte;
    quit : boolean;
begin
 quit := false;
 result := false;
 i := x;
 if (x < gamesize-1) then
  repeat
   inc(i);
   case game[i,y].ftype of
    ftHbridge  : ;
    ftNone,
    ftVBridge : quit := true;
    ftIsland : result := true;
   end;
  until result or quit;
 if result then n := i;
end;

function GetDownIsCoords(x,y : byte; var n : byte) : boolean;
//x,y are island coords
//if true n is down island y
var i : byte;
    quit : boolean;
begin
 quit := false;
 result := false;
 i := y;
 if (y < gamesize - 1) then
  repeat
   inc(i);
   case game[x,i].ftype of
    ftVbridge : ;
    ftNone,
    ftHBridge : quit := true;
    ftIsland : result := true;
   end;
  until result or quit;
 if result then n := i;
end;

procedure LightGroup(grp : byte);
//paint thick red lines between group grp islands
var i : byte;
    rA,rB : Trect;
    n : byte;
begin
 with form1.paintbox1.canvas do
  begin
   pen.color := $ff;
   pen.width := 3;
   for i := 1 to islandcount do
    with Island[i] do
     if (groupNr = grp) then
       begin
        rA := getfieldrect(x,y);
        if getRightIsCoords(x,y,n) then
         begin
          rB := getFieldrect(n,y);
          moveto(rA.Left + 20,rA.Top + 20);
          lineto(rB.left+20,rB.Top+20);
         end;
        if getDownIsCoords(x,y,n) then
         begin
          rB := getFieldRect(x,n);
          moveto(rA.Left+20,rA.Top+20);
          lineto(rB.Left+20,rB.Top+20);
         end;
       end;//if game
  end;
end;


end.
